<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: opentelemetry/proto/profiles/v1development/profiles.proto

namespace Opentelemetry\Proto\Profiles\V1development;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Each Sample records values encountered in some program
 * context. The program context is typically a stack trace, perhaps
 * augmented with auxiliary information like the thread-id, some
 * indicator of a higher level request being handled etc.
 *
 * Generated from protobuf message <code>opentelemetry.proto.profiles.v1development.Sample</code>
 */
class Sample extends \Google\Protobuf\Internal\Message
{
    /**
     * locations_start_index along with locations_length refers to to a slice of locations in Profile.location_indices.
     *
     * Generated from protobuf field <code>int32 locations_start_index = 1;</code>
     */
    protected $locations_start_index = 0;
    /**
     * locations_length along with locations_start_index refers to a slice of locations in Profile.location_indices.
     * Supersedes location_index.
     *
     * Generated from protobuf field <code>int32 locations_length = 2;</code>
     */
    protected $locations_length = 0;
    /**
     * The type and unit of each value is defined by the corresponding
     * entry in Profile.sample_type. All samples must have the same
     * number of values, the same as the length of Profile.sample_type.
     * When aggregating multiple samples into a single sample, the
     * result has a list of values that is the element-wise sum of the
     * lists of the originals.
     *
     * Generated from protobuf field <code>repeated int64 value = 3;</code>
     */
    private $value;
    /**
     * References to attributes in Profile.attribute_table. [optional]
     *
     * Generated from protobuf field <code>repeated int32 attribute_indices = 4;</code>
     */
    private $attribute_indices;
    /**
     * Reference to link in Profile.link_table. [optional]
     *
     * Generated from protobuf field <code>optional int32 link_index = 5;</code>
     */
    protected $link_index = null;
    /**
     * Timestamps associated with Sample represented in nanoseconds. These timestamps are expected
     * to fall within the Profile's time range. [optional]
     *
     * Generated from protobuf field <code>repeated uint64 timestamps_unix_nano = 6;</code>
     */
    private $timestamps_unix_nano;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type int $locations_start_index
     *           locations_start_index along with locations_length refers to to a slice of locations in Profile.location_indices.
     *     @type int $locations_length
     *           locations_length along with locations_start_index refers to a slice of locations in Profile.location_indices.
     *           Supersedes location_index.
     *     @type int[]|string[]|\Google\Protobuf\Internal\RepeatedField $value
     *           The type and unit of each value is defined by the corresponding
     *           entry in Profile.sample_type. All samples must have the same
     *           number of values, the same as the length of Profile.sample_type.
     *           When aggregating multiple samples into a single sample, the
     *           result has a list of values that is the element-wise sum of the
     *           lists of the originals.
     *     @type int[]|\Google\Protobuf\Internal\RepeatedField $attribute_indices
     *           References to attributes in Profile.attribute_table. [optional]
     *     @type int $link_index
     *           Reference to link in Profile.link_table. [optional]
     *     @type int[]|string[]|\Google\Protobuf\Internal\RepeatedField $timestamps_unix_nano
     *           Timestamps associated with Sample represented in nanoseconds. These timestamps are expected
     *           to fall within the Profile's time range. [optional]
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Opentelemetry\Proto\Profiles\V1Development\Profiles::initOnce();
        parent::__construct($data);
    }

    /**
     * locations_start_index along with locations_length refers to to a slice of locations in Profile.location_indices.
     *
     * Generated from protobuf field <code>int32 locations_start_index = 1;</code>
     * @return int
     */
    public function getLocationsStartIndex()
    {
        return $this->locations_start_index;
    }

    /**
     * locations_start_index along with locations_length refers to to a slice of locations in Profile.location_indices.
     *
     * Generated from protobuf field <code>int32 locations_start_index = 1;</code>
     * @param int $var
     * @return $this
     */
    public function setLocationsStartIndex($var)
    {
        GPBUtil::checkInt32($var);
        $this->locations_start_index = $var;

        return $this;
    }

    /**
     * locations_length along with locations_start_index refers to a slice of locations in Profile.location_indices.
     * Supersedes location_index.
     *
     * Generated from protobuf field <code>int32 locations_length = 2;</code>
     * @return int
     */
    public function getLocationsLength()
    {
        return $this->locations_length;
    }

    /**
     * locations_length along with locations_start_index refers to a slice of locations in Profile.location_indices.
     * Supersedes location_index.
     *
     * Generated from protobuf field <code>int32 locations_length = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setLocationsLength($var)
    {
        GPBUtil::checkInt32($var);
        $this->locations_length = $var;

        return $this;
    }

    /**
     * The type and unit of each value is defined by the corresponding
     * entry in Profile.sample_type. All samples must have the same
     * number of values, the same as the length of Profile.sample_type.
     * When aggregating multiple samples into a single sample, the
     * result has a list of values that is the element-wise sum of the
     * lists of the originals.
     *
     * Generated from protobuf field <code>repeated int64 value = 3;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * The type and unit of each value is defined by the corresponding
     * entry in Profile.sample_type. All samples must have the same
     * number of values, the same as the length of Profile.sample_type.
     * When aggregating multiple samples into a single sample, the
     * result has a list of values that is the element-wise sum of the
     * lists of the originals.
     *
     * Generated from protobuf field <code>repeated int64 value = 3;</code>
     * @param int[]|string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setValue($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::INT64);
        $this->value = $arr;

        return $this;
    }

    /**
     * References to attributes in Profile.attribute_table. [optional]
     *
     * Generated from protobuf field <code>repeated int32 attribute_indices = 4;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAttributeIndices()
    {
        return $this->attribute_indices;
    }

    /**
     * References to attributes in Profile.attribute_table. [optional]
     *
     * Generated from protobuf field <code>repeated int32 attribute_indices = 4;</code>
     * @param int[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAttributeIndices($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::INT32);
        $this->attribute_indices = $arr;

        return $this;
    }

    /**
     * Reference to link in Profile.link_table. [optional]
     *
     * Generated from protobuf field <code>optional int32 link_index = 5;</code>
     * @return int
     */
    public function getLinkIndex()
    {
        return isset($this->link_index) ? $this->link_index : 0;
    }

    public function hasLinkIndex()
    {
        return isset($this->link_index);
    }

    public function clearLinkIndex()
    {
        unset($this->link_index);
    }

    /**
     * Reference to link in Profile.link_table. [optional]
     *
     * Generated from protobuf field <code>optional int32 link_index = 5;</code>
     * @param int $var
     * @return $this
     */
    public function setLinkIndex($var)
    {
        GPBUtil::checkInt32($var);
        $this->link_index = $var;

        return $this;
    }

    /**
     * Timestamps associated with Sample represented in nanoseconds. These timestamps are expected
     * to fall within the Profile's time range. [optional]
     *
     * Generated from protobuf field <code>repeated uint64 timestamps_unix_nano = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getTimestampsUnixNano()
    {
        return $this->timestamps_unix_nano;
    }

    /**
     * Timestamps associated with Sample represented in nanoseconds. These timestamps are expected
     * to fall within the Profile's time range. [optional]
     *
     * Generated from protobuf field <code>repeated uint64 timestamps_unix_nano = 6;</code>
     * @param int[]|string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setTimestampsUnixNano($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::UINT64);
        $this->timestamps_unix_nano = $arr;

        return $this;
    }

}

